# TODO
# - nagios plugin (see it's files section for details)
#
# Conditional build:
%bcond_without	apidocs		# do not build and package API docs
%bcond_with	mapiproxy	# mapiproxy suite (disabled with Samba 4.4+)
%bcond_with	mapitest	# mapitest utility (disabled with Samba 4.4+)
%bcond_with	python		# build python package (requires disabled mapiproxy)

%define	cname	VULCAN
Summary:	OpenChange - portable implementation of MS Exchange Server and Exchange protocols
Summary(pl.UTF-8):	OpenChange - przenośna implementacja serwera oraz protokołów MS Exchange
Name:		openchange
Version:	2.3
Release:	58
License:	GPL v3+
Group:		Libraries
#Source0Download: https://github.com/openchange/openchange/releases
Source0:	https://github.com/openchange/openchange/archive/%{name}-%{version}-%{cname}.tar.gz
# Source0-md5:	96c13c78c2bcbd7040f7848746284b9f
Patch0:		disable-mapiproxy.patch
Patch1:		%{name}-link.patch
Patch2:		flex2.6.patch
Patch3:		samba-4.2.patch
Patch4:		fix-connection-args.patch
Patch5:		samba-4.4.patch
Patch6:		%{name}-covscan.patch
Patch7:		%{name}-samba-4.10-macros.patch
Patch8:		%{name}-libical.patch
Patch9:		samba-4.11.patch
Patch10:	samba-4.12.patch
Patch11:	%{name}-nanomsg.patch
URL:		https://github.com/openchange
BuildRequires:	QtCore-devel >= 4.3.0
BuildRequires:	QtGui-devel >= 4.3.0
BuildRequires:	autoconf >= 2.57
BuildRequires:	automake
BuildRequires:	check-devel
BuildRequires:	doxygen
BuildRequires:	ldb-devel
BuildRequires:	libical-devel >= 0.46
BuildRequires:	libmagic-devel
BuildRequires:	libmemcached-devel >= 1.0.18
BuildRequires:	libpcap-devel
BuildRequires:	libstdc++-devel
BuildRequires:	mysql-devel
BuildRequires:	nanomsg-devel >= 1.0.0
BuildRequires:	perl-base
BuildRequires:	pkgconfig >= 1:0.20
BuildRequires:	popt-devel
%if %{with python}
BuildRequires:	python-devel >= 1:2.7
BuildRequires:	python-samba >= 4.2.2
%endif
BuildRequires:	rpm-build >= 4.6
BuildRequires:	rpmbuild(macros) >= 1.752
# with DCERCP multiplex and pending call support (upstream 4.1.18+ or 4.2.2+)
# samba-4.10-macros patch requires samba-pidl 4.10+
BuildRequires:	samba-devel >= 4.10
BuildRequires:	samba-pidl >= 4.10
BuildRequires:	sed >= 4.0
BuildRequires:	subunit-devel
BuildRequires:	talloc-devel
BuildRequires:	tdb-devel
BuildRequires:	zlib-devel
Requires:	%{name}-libs = %{version}-%{release}
%{?with_python:Requires:	python-openchange = %{version}-%{release}}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreq_perl		utils

%description
OpenChange is a portable Open Source implementation of Microsoft
Exchange server and Exchange protocols. It provides a complete
solution to interoperate with Microsoft Outlook clients or Microsoft
Exchange servers.

OpenChange client-side library is used in existing messaging clients
and is the solution in new projects to communicate natively with
Microsoft Exchange and Exchange-compatible servers. OpenChange server
is a transparent Microsoft Exchange server replacement using native
Exchange protocols and does not require any plugin installation in
Outlook.

%description -l pl.UTF-8
OpenChange to przenośna, mająca otwarte źródła implementacja serwera
oraz protokołów Microsoft Exchange. Dostarcza kompletne rozwiązanie
pozwalające współpracować z klientami Microsoft Outlook oraz serwerami
Microsoft Exchange.

Biblioteka kliencka OpenChange jest używana przez istniejących
klientów pocztowych i pozwalają na natywną komunikację z serwerami
Microsoft Exchange oraz zgodnymi. Serwer OpenChange to przezroczysty
zamiennik serwera Microsoft Exchange wykorzystujący natywne protokoły
Exchange, nie wymagający instalowania żadnych wtyczek w Outlooku.

%package libs
Summary:	OpenChange client libraries
Summary(pl.UTF-8):	Biblioteki klienckie OpenChange
Group:		Libraries

%description libs
OpenChange client libraries.

%description libs -l pl.UTF-8
Biblioteki klienckie OpenChange.

%package devel
Summary:	Header files for OpenChange libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek OpenChange
Group:		Development/Libraries
Requires:	%{name}-libs = %{version}-%{release}
Requires:	ldb-devel
Requires:	samba-devel >= 4.2.2
Requires:	talloc-devel
Requires:	tevent-devel
Requires:	zlib-devel

%description devel
Header files for OpenChange libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek OpenChange.

%package c++
Summary:	C++ interface to OpenChange MAPI library
Summary(pl.UTF-8):	Interfejs C++ do biblioteki OpenChange MAPI
Group:		Libraries
Requires:	%{name}-libs = %{version}-%{release}

%description c++
C++ interface to OpenChange MAPI library.

%description c++ -l pl.UTF-8
Interfejs C++ do biblioteki OpenChange MAPI.

%package c++-devel
Summary:	Header files of C++ interface to OpenChange MAPI library
Summary(pl.UTF-8):	Pliki nagłówkowe interfejsu C++ do biblioteki OpenChange MAPI
Group:		Development/Libraries
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	%{name}-devel = %{version}-%{release}
Requires:	libstdc++-devel

%description c++-devel
Header files of C++ interface to OpenChange MAPI library.

%description c++-devel -l pl.UTF-8
Pliki nagłówkowe interfejsu C++ do biblioteki OpenChange MAPI.

%package qt
Summary:	Qt interface to OpenChange MAPI library
Summary(pl.UTF-8):	Interfejs Qt do biblioteki OpenChange MAPI
Group:		Libraries
Requires:	%{name}-c++ = %{version}-%{release}
Requires:	QtCore >= 4.3.0
Requires:	QtGui >= 4.3.0

%description qt
Qt interface to OpenChange MAPI library.

%description qt -l pl.UTF-8
Interfejs Qt do biblioteki OpenChange MAPI.

%package qt-devel
Summary:	Header files of Qt interface to OpenChange MAPI library
Summary(pl.UTF-8):	Pliki nagłówkowe interfejsu Qt do biblioteki OpenChange MAPI
Group:		Development/Libraries
Requires:	%{name}-qt = %{version}-%{release}
Requires:	QtGui-devel >= 4.3.0

%description qt-devel
Header files of Qt interface to OpenChange MAPI library.

%description qt-devel -l pl.UTF-8
Pliki nagłówkowe interfejsu Qt do biblioteki OpenChange MAPI.

%package apidocs
Summary:	API documentation for OpenChange libraries
Summary(pl.UTF-8):	Dokumentacja API bibliotek OpenChange
Group:		Documentation
BuildArch:	noarch

%description apidocs
API documentation for OpenChange libraries.

%description apidocs -l pl.UTF-8
Dokumentacja API bibliotek OpenChange.

%package -n python-openchange
Summary:	Python interface to OpenChange libraries
Summary(pl.UTF-8):	Interfejs Pythona do bibliotek OpenChange
Group:		Libraries/Python
Requires:	%{name}-libs = %{version}-%{release}

%description -n python-openchange
Python interface to OpenChange libraries.

%description -n python-openchange -l pl.UTF-8
Interfejs Pythona do bibliotek OpenChange.

%package -n nagios-plugin-openchange
Summary:	Nagios plugin to check Exchange/OpenChange services
Summary(pl.UTF-8):	Wtyczka Nagiosa do sprawdzania usług Exchange/OpenChange
Group:		Networking
Requires:	%{name} = %{version}-%{release}
Requires:	nagios

%description -n nagios-plugin-openchange
Nagios plugin to check Exchange/OpenChange services.

%description -n nagios-plugin-openchange -l pl.UTF-8
Wtyczka Nagiosa do sprawdzania usług Exchange/OpenChange.

%prep
%setup -q -n %{name}-%{name}-%{version}-%{cname}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

# no switch for verbose mode, enable manually :/
%{__sed} -i -e 's/^	@\(\$(\(PIDL\|CC\|CXX\|MOC\)\)/	\1/' Makefile

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
# instead of calling automake (there is no Makefile.am)
cp -f /usr/share/automake/{compile,missing} .
%configure \
	--datadir=%{_datadir}/openchange \
	--enable-openchange-qt4 \
	%{?with_python:--enable-pyopenchange} \
	--with-modulesdir=%{_libdir}/openchange/modules
%{__make}

%if %{with apidocs}
%{__make} doxygen
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# doxygen generated man pages are messy; use HTML docs and install man1 pages manually
%if 0
%{__make} installman \
	DESTDIR=$RPM_BUILD_ROOT
%else
install -d $RPM_BUILD_ROOT%{_mandir}/man1
cp doc/man/man1/* $RPM_BUILD_ROOT%{_mandir}/man1
%endif

# missing from make install
install -d $RPM_BUILD_ROOT%{_includedir}/libqtmapi
cp -p qt/lib/*.h $RPM_BUILD_ROOT%{_includedir}/libqtmapi
cp -a libqtmapi.so.*.* libqtmapi.so $RPM_BUILD_ROOT%{_libdir}

# tests
%{__rm} $RPM_BUILD_ROOT%{_bindir}/test_asyncnotif
%if %{without mapitest}
%{__rm} $RPM_BUILD_ROOT%{_mandir}/man1/mapitest.1
%endif

/sbin/ldconfig -n $RPM_BUILD_ROOT%{_libdir}

%py_comp $RPM_BUILD_ROOT%{py_sitedir}
%py_ocomp $RPM_BUILD_ROOT%{py_sitedir}
%py_postclean

%clean
rm -rf $RPM_BUILD_ROOT

%post	libs -p /sbin/ldconfig
%postun	libs -p /sbin/ldconfig

%post	c++ -p /sbin/ldconfig
%postun	c++ -p /sbin/ldconfig

%post	qt -p /sbin/ldconfig
%postun	qt -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CHANGES.md IDL_LICENSE.txt README.md README.smbconf.md doc/howto.txt
%attr(755,root,root) %{_bindir}/exchange2ical
%attr(755,root,root) %{_bindir}/exchange2mbox
%attr(755,root,root) %{_bindir}/mapiprofile
%attr(755,root,root) %{_bindir}/mapipropsdump
%attr(755,root,root) %{_bindir}/openchangeclient
%attr(755,root,root) %{_bindir}/openchangemapidump
%attr(755,root,root) %{_bindir}/openchangepfadmin
%attr(755,root,root) %{_bindir}/rpcextract
%attr(755,root,root) %{_bindir}/schemaIDGUID
%dir %{_datadir}/openchange
%dir %{_datadir}/openchange/setup
%{_datadir}/openchange/setup/profiles
%{_mandir}/man1/exchange2ical.1*
%{_mandir}/man1/exchange2mbox.1*
%{_mandir}/man1/mapiprofile.1*
%{_mandir}/man1/openchangeclient.1*
%{_mandir}/man1/openchangepfadmin.1*
%if %{with mapiproxy}
%attr(755,root,root) %{_bindir}/ocnotify
%attr(755,root,root) %{_sbindir}/openchange_group
%attr(755,root,root) %{_sbindir}/openchange_migrate
%attr(755,root,root) %{_sbindir}/openchange_neworganization
%attr(755,root,root) %{_sbindir}/openchange_newuser
%attr(755,root,root) %{_sbindir}/openchange_provision
# XXX: dir specified by dcerpc_server.pc file, should belong to samba or samba-libs
%dir %{_libdir}/samba/dcerpc_server
%attr(755,root,root) %{_libdir}/samba/dcerpc_server/dcesrv_asyncemsmdb.so
%attr(755,root,root) %{_libdir}/samba/dcerpc_server/dcesrv_mapiproxy.so
%dir %{_libdir}/openchange
%dir %{_libdir}/openchange/modules
%dir %{_libdir}/openchange/modules/dcerpc_mapiproxy
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy/mpm_cache.so
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy/mpm_downgrade.so
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy/mpm_dummy.so
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy/mpm_pack.so
%dir %{_libdir}/openchange/modules/dcerpc_mapiproxy_server
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy_server/exchange_ds_rfr.so
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy_server/exchange_emsmdb.so
%attr(755,root,root) %{_libdir}/openchange/modules/dcerpc_mapiproxy_server/exchange_nsp.so
%{_datadir}/openchange/setup/mapistore
%{_datadir}/openchange/setup/openchangedb
%dir %{_datadir}/samba/setup/AD
%{_datadir}/samba/setup/AD/oc_provision_*.ldif
%{_datadir}/samba/setup/AD/provision_schema_basedn_modify.ldif
%{_datadir}/samba/setup/AD/update_now.ldif
%{_datadir}/samba/setup/AD/prefixMap.txt
%endif
%if %{with mapitest}
%attr(755,root,root) %{_bindir}/mapitest
%{_datadir}/openchange/mapitest
%{_mandir}/man1/mapitest.1*
%endif

%files libs
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmapi.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmapi.so.0
%attr(755,root,root) %{_libdir}/libmapiadmin.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmapiadmin.so.0
%attr(755,root,root) %{_libdir}/libocpf.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libocpf.so.0
%if %{with mapiproxy}
%attr(755,root,root) %{_libdir}/libmapiproxy.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmapiproxy.so.0
%attr(755,root,root) %{_libdir}/libmapiserver.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmapiserver.so.0
%attr(755,root,root) %{_libdir}/libmapistore.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmapistore.so.0
%endif

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmapi.so
%attr(755,root,root) %{_libdir}/libmapiadmin.so
%attr(755,root,root) %{_libdir}/libocpf.so
%{_includedir}/gen_ndr
%{_includedir}/libmapi
%{_includedir}/libmapiadmin
%{_includedir}/libocpf
%{_pkgconfigdir}/libmapi.pc
%{_pkgconfigdir}/libmapiadmin.pc
%{_pkgconfigdir}/libocpf.pc
%if %{with mapiproxy}
%attr(755,root,root) %{_libdir}/libmapiproxy.so
%attr(755,root,root) %{_libdir}/libmapiserver.so
%attr(755,root,root) %{_libdir}/libmapistore.so
%{_includedir}/mapistore
%{_includedir}/libmapiproxy.h
%{_includedir}/libmapiserver.h
%{_pkgconfigdir}/libmapiproxy.pc
%{_pkgconfigdir}/libmapiserver.pc
%{_pkgconfigdir}/libmapistore.pc
%endif

%files c++
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmapipp.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libmapipp.so.0

%files c++-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libmapipp.so
%{_includedir}/libmapi++
%{_pkgconfigdir}/libmapi++.pc

%files qt
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libqtmapi.so.*.*
%attr(755,root,root) %ghost %{_libdir}/libqtmapi.so.0

%files qt-devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libqtmapi.so
%{_includedir}/libqtmapi

%if %{with apidocs}
%files apidocs
%defattr(644,root,root,755)
%doc apidocs/html/*
%endif

%if %{with python}
%files -n python-openchange
%defattr(644,root,root,755)
%dir %{py_sitedir}/openchange
%attr(755,root,root) %{py_sitedir}/openchange/mapi.so
%attr(755,root,root) %{py_sitedir}/openchange/mapistore.so
%if %{with mapiproxy}
%{py_sitedir}/openchange/*.py[co]
%{py_sitedir}/openchange/migration
%{py_sitedir}/openchange/tests
%{py_sitedir}/openchange/utils
%{py_sitedir}/openchange/web
%endif
%endif

%files -n nagios-plugin-openchange
%defattr(644,root,root,755)
# R: perl, openchangeclient
# FIXME: use /usr/lib/nagios/plugins dir and make package noarch
%attr(755,root,root) %{_libdir}/nagios/check_exchange
# default profile database - should be /etc/...
#%config(noreplace) %verify(not md5 mtime size) %{_libdir}/nagios/plugins/check_exchange.ldb
%changelog
* Tue Jun 08 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/openchange.git;a=log;h=master

* Tue Jun 08 2021 Jakub Bogusz <qboosh@pld-linux.org> 8fae5c8
- release 58

* Thu May 06 2021 Jakub Bogusz <qboosh@pld-linux.org> 7c1401b
- release 57 (samba 4.13.8)

* Fri Mar 26 2021 Jakub Bogusz <qboosh@pld-linux.org> 4d4287e
- release 56

* Fri Mar 26 2021 Jakub Bogusz <qboosh@pld-linux.org> 1b9a980
- rediffed

* Fri Mar 26 2021 Jan Rękorajski <baggins@pld-linux.org> 068f555
- release 55 (by relup.sh)

* Thu Mar 25 2021 Jakub Bogusz <qboosh@pld-linux.org> df1197a
- release 54 (samba 4.13.7)

* Sun Mar 07 2021 Jan Rękorajski <baggins@pld-linux.org> aebab8f
- unconditional noarch subpackages

* Sat Jan 09 2021 Jakub Bogusz <qboosh@pld-linux.org> 3799929
- updated noarch rule
- fix build with autoconf 2.70
- release 53 (samba 4.13.3)

* Tue Aug 18 2020 Jakub Bogusz <qboosh@pld-linux.org> 1b4425d
- release 51 (samba 4.12.6)

* Sat May 23 2020 Jakub Bogusz <qboosh@pld-linux.org> b5f7e37
- added nanomsg patch (adjust for .pc file rename in nanomsg 1.0.0+)
- release 51 (rebuild with samba 4.12.3)

* Thu Apr 23 2020 Jan Rękorajski <baggins@pld-linux.org> 23b2855
- release 50 (by relup.sh)

* Wed Apr 08 2020 Jan Rękorajski <baggins@pld-linux.org> d23f825
- fix building with samba 4.12
- rel 49

* Sat Mar 28 2020 Jan Rękorajski <baggins@pld-linux.org> 80627a7
- release 48 (by relup.sh)

* Sun Feb 09 2020 Jan Rękorajski <baggins@pld-linux.org> 29dcaaf
- fix perl deps in nagios-plugin-openchange package
- rel 47

* Sun Feb 09 2020 Jan Rękorajski <baggins@pld-linux.org> c70cf5e
- release 46 (by relup.sh)

* Sat Jan 11 2020 Jakub Bogusz <qboosh@pld-linux.org> aa25485
- release 45 (rebuild with samba 4.11.4)

* Sat Nov 02 2019 Jan Rękorajski <baggins@pld-linux.org> 224a9b8
- fix building with samba 4.11
- rel 44

* Thu Oct 17 2019 Jakub Bogusz <qboosh@pld-linux.org> 4db9cff
- release 43 (for samba 4.10.9)

* Thu Oct 17 2019 Jakub Bogusz <qboosh@pld-linux.org> 4b49de4
- release 42 (for samba 4.10.8)

* Wed Jul 24 2019 Jakub Bogusz <qboosh@pld-linux.org> 8d7bc76
- release 41 (samba 4.10.6)

